#############################################################
#### decission function2 on ImSnow data plus, TA_TSS   ######
####              filename= funktion2               #########
#############################################################


##TA treshold 1.2°C
DC1<-function(RH,HS,TA,TSS, SP,A,IM,de,PS ){
  if(RH<0.60){   #test if RH is suvicient for precipitation
    PS<- 0
  } else{
    if(HS>0& (TA-TSS>3)){
      PS<-0
    }else{
      if (HS>0.10){PS<- HS1(HS, TA, SP, A, de,PS)}    #snowhight test     A
      if(HS<0.10 &HS>0.02){PS<- HS2(HS, TA, SP, A, de,PS)}      #snowhight test     B
      if (HS<0.02){PS<- HS3(TA,IM, A,SP,PS )}           #snowhight test       C
    }
    if(is.na(HS)){
      PS<-0
      # PS<- SP
      if(is.na(PS)){PS<- A}}}
  return(PS)
}

######################for stations without summer Imis measurments

DC3<-function(RH,HS,TA,TSS, SP,A,de,PS ){
  if(RH<0.60){   #test if RH is suvicient for precipitation
    PS<- 0
  } else{
    if(HS>0& (TA-TSS>3)){
      PS<-0
    }else{
      if (HS>0.02){PS<-HS1(HS, TA, SP, A, de,PS)}    #snowhight test     A
      if (HS<0.02){PS<- HS34(A,SP, PS) }           #snowhight test       C
    }
    if(is.na(HS)){
      PS<- SP
      if(is.na(PS)){PS<- A}}}
  return(PS)
}



############### function A for HS>10 cm##################

HS1<- function(HS, TA, SP, A,de, PS){
  if (TA< 274.15){
    PS<- SP
  }
  if (TA>= 274.15){
    PS<- A
  }
 if(is.na(PS)==TRUE){PS<- A}
 if(is.na(PS)==TRUE){PS<- SP}
  return (PS)
}




############### function B for HS between 3 and 10 cm###################

HS2<- function(HS, TA, SP, A, de,PS){
  if(TA>274.15){
    PS<- A} else { 
      if(!is.na(de)&de==FALSE) {PS<- SP} else{ PS<- A
      }}
  if(is.na(PS)==TRUE){PS<- A}
  if(is.na(PS)==TRUE){PS<- SP}
  return(PS)
}

############### function B for HS smaller 3cm###################
HS3<- function(TA, IM,A,SP, PS ){
  PS<- IM
  if(is.na(IM)==TRUE){
    PS<- A
    if(is.na(A)==TRUE){PS<- SP}
  }
  return(PS)
}


HS34<- function(A,SP, PS ){
  PS<- A
  if(is.na(A)==TRUE){PS<- SP}
  return(PS)
}




#########################################################################
#################test if HS is increasing or decreasing##################

de<- function(HS,w){
  N<- length(HS); s=rep(NA,N)
  for (i in (w+1):(N-w-1)) {s[i]<-(is.unsorted(HS[(i-w):(i)]))};
  s
}


